/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    var SyntaxWalker = (function () {
        function SyntaxWalker() {
        }
        SyntaxWalker.prototype.walk = function (node) {
            this.visitNode(node);
        };
        SyntaxWalker.prototype.visitAnyKeyword = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitArrowFunction = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitBinaryExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitBindingElement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitBlock = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitBreakStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitCallExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitCaseClause = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitClassDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitCatchClause = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitConditionalExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitConstructorDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitConstructorType = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitContinueStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitDebuggerStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitDefaultClause = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitDoStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitElementAccessExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitEnumDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitExportAssignment = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitExpressionStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitForStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitForInStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitForOfStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitFunctionDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitFunctionExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitFunctionType = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitGetAccessor = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitIdentifier = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitIfStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitImportDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitImportEqualsDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitIndexSignatureDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitInterfaceDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitLabeledStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitMethodDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitMethodSignature = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitModuleDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitNamedImports = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitNamespaceImport = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitNewExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitObjectLiteralExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitParameterDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitPostfixUnaryExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitPrefixUnaryExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitPropertyAccessExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitPropertyAssignment = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitPropertyDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitPropertySignature = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitRegularExpressionLiteral = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitReturnStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitSetAccessor = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitSourceFile = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitSwitchStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitTemplateExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitThrowStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitTryStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitTypeAssertionExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitTypeLiteral = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitVariableDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitVariableStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitWhileStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitNode = function (node) {
            switch (node.kind) {
                case 112 /* AnyKeyword */:
                    this.visitAnyKeyword(node);
                    break;
                case 152 /* BindingElement */:
                    this.visitBindingElement(node);
                    break;
                case 163 /* ArrowFunction */:
                    this.visitArrowFunction(node);
                    break;
                case 169 /* BinaryExpression */:
                    this.visitBinaryExpression(node);
                    break;
                case 152 /* BindingElement */:
                    this.visitBindingElement(node);
                    break;
                case 179 /* Block */:
                    this.visitBlock(node);
                    break;
                case 190 /* BreakStatement */:
                    this.visitBreakStatement(node);
                    break;
                case 157 /* CallExpression */:
                    this.visitCallExpression(node);
                    break;
                case 220 /* CaseClause */:
                    this.visitCaseClause(node);
                    break;
                case 201 /* ClassDeclaration */:
                    this.visitClassDeclaration(node);
                    break;
                case 223 /* CatchClause */:
                    this.visitCatchClause(node);
                    break;
                case 170 /* ConditionalExpression */:
                    this.visitConditionalExpression(node);
                    break;
                case 135 /* Constructor */:
                    this.visitConstructorDeclaration(node);
                    break;
                case 143 /* ConstructorType */:
                    this.visitConstructorType(node);
                    break;
                case 189 /* ContinueStatement */:
                    this.visitContinueStatement(node);
                    break;
                case 197 /* DebuggerStatement */:
                    this.visitDebuggerStatement(node);
                    break;
                case 221 /* DefaultClause */:
                    this.visitDefaultClause(node);
                    break;
                case 184 /* DoStatement */:
                    this.visitDoStatement(node);
                    break;
                case 156 /* ElementAccessExpression */:
                    this.visitElementAccessExpression(node);
                    break;
                case 204 /* EnumDeclaration */:
                    this.visitEnumDeclaration(node);
                    break;
                case 214 /* ExportAssignment */:
                    this.visitExportAssignment(node);
                    break;
                case 182 /* ExpressionStatement */:
                    this.visitExpressionStatement(node);
                    break;
                case 186 /* ForStatement */:
                    this.visitForStatement(node);
                    break;
                case 187 /* ForInStatement */:
                    this.visitForInStatement(node);
                    break;
                case 188 /* ForOfStatement */:
                    this.visitForOfStatement(node);
                    break;
                case 200 /* FunctionDeclaration */:
                    this.visitFunctionDeclaration(node);
                    break;
                case 162 /* FunctionExpression */:
                    this.visitFunctionExpression(node);
                    break;
                case 142 /* FunctionType */:
                    this.visitFunctionType(node);
                    break;
                case 136 /* GetAccessor */:
                    this.visitGetAccessor(node);
                    break;
                case 65 /* Identifier */:
                    this.visitIdentifier(node);
                    break;
                case 183 /* IfStatement */:
                    this.visitIfStatement(node);
                    break;
                case 209 /* ImportDeclaration */:
                    this.visitImportDeclaration(node);
                    break;
                case 208 /* ImportEqualsDeclaration */:
                    this.visitImportEqualsDeclaration(node);
                    break;
                case 140 /* IndexSignature */:
                    this.visitIndexSignatureDeclaration(node);
                    break;
                case 202 /* InterfaceDeclaration */:
                    this.visitInterfaceDeclaration(node);
                    break;
                case 194 /* LabeledStatement */:
                    this.visitLabeledStatement(node);
                    break;
                case 134 /* MethodDeclaration */:
                    this.visitMethodDeclaration(node);
                    break;
                case 133 /* MethodSignature */:
                    this.visitMethodSignature(node);
                    break;
                case 205 /* ModuleDeclaration */:
                    this.visitModuleDeclaration(node);
                    break;
                case 212 /* NamedImports */:
                    this.visitNamedImports(node);
                    break;
                case 211 /* NamespaceImport */:
                    this.visitNamespaceImport(node);
                    break;
                case 158 /* NewExpression */:
                    this.visitNewExpression(node);
                    break;
                case 154 /* ObjectLiteralExpression */:
                    this.visitObjectLiteralExpression(node);
                    break;
                case 129 /* Parameter */:
                    this.visitParameterDeclaration(node);
                    break;
                case 168 /* PostfixUnaryExpression */:
                    this.visitPostfixUnaryExpression(node);
                    break;
                case 167 /* PrefixUnaryExpression */:
                    this.visitPrefixUnaryExpression(node);
                    break;
                case 155 /* PropertyAccessExpression */:
                    this.visitPropertyAccessExpression(node);
                    break;
                case 224 /* PropertyAssignment */:
                    this.visitPropertyAssignment(node);
                    break;
                case 132 /* PropertyDeclaration */:
                    this.visitPropertyDeclaration(node);
                    break;
                case 131 /* PropertySignature */:
                    this.visitPropertySignature(node);
                    break;
                case 9 /* RegularExpressionLiteral */:
                    this.visitRegularExpressionLiteral(node);
                    break;
                case 191 /* ReturnStatement */:
                    this.visitReturnStatement(node);
                    break;
                case 137 /* SetAccessor */:
                    this.visitSetAccessor(node);
                    break;
                case 227 /* SourceFile */:
                    this.visitSourceFile(node);
                    break;
                case 193 /* SwitchStatement */:
                    this.visitSwitchStatement(node);
                    break;
                case 171 /* TemplateExpression */:
                    this.visitTemplateExpression(node);
                    break;
                case 195 /* ThrowStatement */:
                    this.visitThrowStatement(node);
                    break;
                case 196 /* TryStatement */:
                    this.visitTryStatement(node);
                    break;
                case 160 /* TypeAssertionExpression */:
                    this.visitTypeAssertionExpression(node);
                    break;
                case 145 /* TypeLiteral */:
                    this.visitTypeLiteral(node);
                    break;
                case 198 /* VariableDeclaration */:
                    this.visitVariableDeclaration(node);
                    break;
                case 180 /* VariableStatement */:
                    this.visitVariableStatement(node);
                    break;
                case 185 /* WhileStatement */:
                    this.visitWhileStatement(node);
                    break;
                default:
                    this.walkChildren(node);
                    break;
            }
        };
        SyntaxWalker.prototype.walkChildren = function (node) {
            var _this = this;
            ts.forEachChild(node, function (child) { return _this.visitNode(child); });
        };
        return SyntaxWalker;
    })();
    Lint.SyntaxWalker = SyntaxWalker;
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var Lint;
(function (Lint) {
    var RuleWalker = (function (_super) {
        __extends(RuleWalker, _super);
        function RuleWalker(sourceFile, options) {
            _super.call(this);
            this.position = 0;
            this.failures = [];
            this.options = options.ruleArguments;
            this.sourceFile = sourceFile;
            this.limit = this.sourceFile.getFullWidth();
            this.disabledIntervals = options.disabledIntervals;
            this.ruleName = options.ruleName;
        }
        RuleWalker.prototype.getSourceFile = function () {
            return this.sourceFile;
        };
        RuleWalker.prototype.getFailures = function () {
            return this.failures;
        };
        /*
        public getPosition() {
            return this.position;
        }
        */
        RuleWalker.prototype.getLimit = function () {
            return this.limit;
        };
        /*
        public positionAfter(...nodes: ts.Node[]): number {
            var position = this.getPosition();
            nodes.forEach((node) => {
                if (node !== null) {
                    position += node.getFullWidth();
                }
            });
            return position;
        }
        */
        RuleWalker.prototype.getOptions = function () {
            return this.options;
        };
        RuleWalker.prototype.hasOption = function (option) {
            if (this.options) {
                return this.options.indexOf(option) !== -1;
            }
            else {
                return false;
            }
        };
        RuleWalker.prototype.skip = function (node) {
            this.position += node.getFullWidth();
        };
        // create a failure at the given position
        RuleWalker.prototype.createFailure = function (start, width, failure) {
            var from = (start > this.limit) ? this.limit : start;
            var to = ((start + width) > this.limit) ? this.limit : (start + width);
            return new Lint.RuleFailure(this.sourceFile, from, to, failure, this.ruleName);
        };
        RuleWalker.prototype.addFailure = function (failure) {
            if (!this.existsFailure(failure)) {
                // don't add failures for a rule if the failure intersects an interval where that rule is disabled
                if (!Lint.doesIntersect(failure, this.disabledIntervals)) {
                    this.failures.push(failure);
                }
            }
        };
        RuleWalker.prototype.existsFailure = function (failure) {
            var filteredFailures = this.failures.filter(function (f) {
                return f.equals(failure);
            });
            return (filteredFailures.length > 0);
        };
        return RuleWalker;
    })(Lint.SyntaxWalker);
    Lint.RuleWalker = RuleWalker;
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    var ScopeAwareRuleWalker = (function (_super) {
        __extends(ScopeAwareRuleWalker, _super);
        function ScopeAwareRuleWalker(sourceFile, options) {
            _super.call(this, sourceFile, options);
            // initialize stack with global scope
            this.scopeStack = [this.createScope()];
        }
        ScopeAwareRuleWalker.prototype.createScope = function () {
            throw Lint.abstract();
        };
        ScopeAwareRuleWalker.prototype.getCurrentScope = function () {
            return this.scopeStack[this.scopeStack.length - 1];
        };
        // get all scopes available at this depth
        ScopeAwareRuleWalker.prototype.getAllScopes = function () {
            return this.scopeStack.slice();
        };
        ScopeAwareRuleWalker.prototype.getCurrentDepth = function () {
            return this.scopeStack.length;
        };
        // callback notifier when a scope begins
        ScopeAwareRuleWalker.prototype.onScopeStart = function () {
            return;
        };
        // callback notifier when a scope ends
        ScopeAwareRuleWalker.prototype.onScopeEnd = function () {
            return;
        };
        ScopeAwareRuleWalker.prototype.visitNode = function (node) {
            var isNewScope = this.isScopeBoundary(node);
            if (isNewScope) {
                this.scopeStack.push(this.createScope());
            }
            this.onScopeStart();
            _super.prototype.visitNode.call(this, node);
            this.onScopeEnd();
            if (isNewScope) {
                this.scopeStack.pop();
            }
        };
        ScopeAwareRuleWalker.prototype.isScopeBoundary = function (node) {
            return node.kind === 200 /* FunctionDeclaration */
                || node.kind === 162 /* FunctionExpression */
                || node.kind === 224 /* PropertyAssignment */
                || node.kind === 225 /* ShorthandPropertyAssignment */
                || node.kind === 134 /* MethodDeclaration */
                || node.kind === 135 /* Constructor */
                || node.kind === 205 /* ModuleDeclaration */
                || node.kind === 163 /* ArrowFunction */
                || node.kind === 161 /* ParenthesizedExpression */
                || node.kind === 201 /* ClassDeclaration */
                || node.kind === 202 /* InterfaceDeclaration */
                || node.kind === 136 /* GetAccessor */
                || node.kind === 137 /* SetAccessor */;
        };
        return ScopeAwareRuleWalker;
    })(Lint.RuleWalker);
    Lint.ScopeAwareRuleWalker = ScopeAwareRuleWalker;
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    var Formatters;
    (function (Formatters) {
        var AbstractFormatter = (function () {
            function AbstractFormatter() {
            }
            /* tslint:disable:no-unused-variable */
            AbstractFormatter.prototype.format = function (failures) {
                throw Lint.abstract();
            };
            return AbstractFormatter;
        })();
        Formatters.AbstractFormatter = AbstractFormatter;
    })(Formatters = Lint.Formatters || (Lint.Formatters = {}));
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * Copyright 2014 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
*/
/* tslint:disable:no-unused-variable */
var Lint;
(function (Lint) {
    function createLanguageServiceHost(fileName, source) {
        var host = {
            getScriptFileNames: function () { return [fileName]; },
            getScriptVersion: function () { return "1"; },
            getScriptSnapshot: function () {
                return {
                    getText: function (start, end) { return source.substring(start, end); },
                    getLength: function () { return source.length; },
                    getLineStartPositions: function () { return ts.computeLineStarts(source); },
                    getChangeRange: function (oldSnapshot) { return undefined; }
                };
            },
            getCurrentDirectory: function () { return ""; },
            getScriptIsOpen: function () { return true; },
            getCompilationSettings: function () { return Lint.createCompilerOptions(); },
            getDefaultLibFileName: function () { return "lib.d.ts"; },
            log: function (message) { }
        };
        return host;
    }
    Lint.createLanguageServiceHost = createLanguageServiceHost;
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    var Rules;
    (function (Rules) {
        var AbstractRule = (function () {
            function AbstractRule(ruleName, value, disabledIntervals) {
                var ruleArguments = [];
                if (Array.isArray(value) && value.length > 1) {
                    ruleArguments = value.slice(1);
                }
                this.value = value;
                this.options = {
                    ruleArguments: ruleArguments,
                    ruleName: ruleName,
                    disabledIntervals: disabledIntervals
                };
            }
            AbstractRule.prototype.getOptions = function () {
                return this.options;
            };
            /* tslint:disable:no-unused-variable */
            AbstractRule.prototype.apply = function (sourceFile) {
                throw Lint.abstract();
            };
            /* tslint:enable:no-unused-variable */
            AbstractRule.prototype.applyWithWalker = function (walker) {
                walker.walk(walker.getSourceFile());
                return walker.getFailures();
            };
            AbstractRule.prototype.isEnabled = function () {
                var value = this.value;
                if (typeof value === "boolean") {
                    return value;
                }
                if (Array.isArray(value) && value.length > 0) {
                    return value[0];
                }
                return false;
            };
            return AbstractRule;
        })();
        Rules.AbstractRule = AbstractRule;
    })(Rules = Lint.Rules || (Lint.Rules = {}));
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    var RuleFailurePosition = (function () {
        function RuleFailurePosition(position, lineAndCharacter) {
            this.position = position;
            this.lineAndCharacter = lineAndCharacter;
        }
        RuleFailurePosition.prototype.getPosition = function () {
            return this.position;
        };
        RuleFailurePosition.prototype.getLineAndCharacter = function () {
            return this.lineAndCharacter;
        };
        RuleFailurePosition.prototype.toJson = function () {
            return {
                position: this.position,
                line: this.lineAndCharacter.line,
                character: this.lineAndCharacter.character
            };
        };
        RuleFailurePosition.prototype.equals = function (ruleFailurePosition) {
            var ll = this.lineAndCharacter;
            var rr = ruleFailurePosition.lineAndCharacter;
            return (this.position === ruleFailurePosition.position &&
                ll.line === rr.line &&
                ll.character === rr.character);
        };
        return RuleFailurePosition;
    })();
    Lint.RuleFailurePosition = RuleFailurePosition;
    var RuleFailure = (function () {
        function RuleFailure(sourceFile, start, end, failure, ruleName) {
            this.sourceFile = sourceFile;
            this.fileName = sourceFile.fileName;
            this.startPosition = this.createFailurePosition(start);
            this.endPosition = this.createFailurePosition(end);
            this.failure = failure;
            this.ruleName = ruleName;
        }
        RuleFailure.prototype.getFileName = function () {
            return this.fileName;
        };
        RuleFailure.prototype.getRuleName = function () {
            return this.ruleName;
        };
        RuleFailure.prototype.getStartPosition = function () {
            return this.startPosition;
        };
        RuleFailure.prototype.getEndPosition = function () {
            return this.endPosition;
        };
        RuleFailure.prototype.getFailure = function () {
            return this.failure;
        };
        RuleFailure.prototype.toJson = function () {
            return {
                name: this.fileName,
                failure: this.failure,
                startPosition: this.startPosition.toJson(),
                endPosition: this.endPosition.toJson(),
                ruleName: this.ruleName
            };
        };
        RuleFailure.prototype.equals = function (ruleFailure) {
            return (this.failure === ruleFailure.getFailure() &&
                this.fileName === ruleFailure.getFileName() &&
                this.startPosition.equals(ruleFailure.getStartPosition()) &&
                this.endPosition.equals(ruleFailure.getEndPosition()));
        };
        RuleFailure.prototype.createFailurePosition = function (position) {
            var lineAndCharacter = this.sourceFile.getLineAndCharacterOfPosition(position);
            var failurePosition = new RuleFailurePosition(position, lineAndCharacter);
            return failurePosition;
        };
        return RuleFailure;
    })();
    Lint.RuleFailure = RuleFailure;
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    var path = require("path");
    function getSourceFile(fileName, source) {
        var normalizedName = path.normalize(fileName).replace(/\\/g, "/");
        var compilerOptions = createCompilerOptions();
        var compilerHost = {
            getSourceFile: function (filenameToGet) {
                if (filenameToGet === normalizedName) {
                    return ts.createSourceFile(filenameToGet, source, compilerOptions.target, true);
                }
            },
            writeFile: function () { return null; },
            getDefaultLibFileName: function () { return "lib.d.ts"; },
            useCaseSensitiveFileNames: function () { return true; },
            getCanonicalFileName: function (filename) { return filename; },
            getCurrentDirectory: function () { return ""; },
            getNewLine: function () { return "\n"; }
        };
        var program = ts.createProgram([normalizedName], compilerOptions, compilerHost);
        return program.getSourceFile(normalizedName);
    }
    Lint.getSourceFile = getSourceFile;
    function createCompilerOptions() {
        return {
            noResolve: true,
            target: 1 /* ES5 */
        };
    }
    Lint.createCompilerOptions = createCompilerOptions;
    function doesIntersect(failure, disabledIntervals) {
        var intersectionExists = false;
        disabledIntervals.forEach(function (disabledInterval) {
            var maxStart = Math.max(disabledInterval.startPosition, failure.getStartPosition().getPosition());
            var minEnd = Math.min(disabledInterval.endPosition, failure.getEndPosition().getPosition());
            if (maxStart <= minEnd) {
                // intervals intersect
                intersectionExists = true;
            }
        });
        return intersectionExists;
    }
    Lint.doesIntersect = doesIntersect;
    function abstract() {
        return "abstract method not implemented";
    }
    Lint.abstract = abstract;
    function scanAllTokens(scanner, callback) {
        var lastStartPos = -1;
        while (scanner.scan() !== 1 /* EndOfFileToken */) {
            var startPos = scanner.getStartPos();
            if (startPos === lastStartPos) {
                break;
            }
            lastStartPos = startPos;
            callback(scanner);
        }
    }
    Lint.scanAllTokens = scanAllTokens;
    /**
     * @returns true if any modifier kinds passed along exist in the given modifiers array
     */
    function hasModifier(modifiers) {
        var modifierKinds = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            modifierKinds[_i - 1] = arguments[_i];
        }
        if (modifiers == null || modifierKinds == null) {
            return false;
        }
        return modifiers.some(function (m) {
            return modifierKinds.some(function (k) { return m.kind === k; });
        });
    }
    Lint.hasModifier = hasModifier;
    function isBlockScopedVariable(node) {
        // determine if the appropriate bit in the parent (VariableDeclarationList) is set,
        // which indicates this is a "let" or "const"
        return (Math.floor(node.parent.flags / 4096 /* Let */) % 2) === 1
            || (Math.floor(node.parent.flags / 8192 /* Const */) % 2) === 1;
    }
    Lint.isBlockScopedVariable = isBlockScopedVariable;
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    /**
     * An AST walker that is aware of block scopes in addition to regular scopes. Block scopes
     * are a superset of regular scopes (new block scopes are created more frequently in a program).
     */
    var BlockScopeAwareRuleWalker = (function (_super) {
        __extends(BlockScopeAwareRuleWalker, _super);
        function BlockScopeAwareRuleWalker(sourceFile, options) {
            _super.call(this, sourceFile, options);
            // initialize stack with global scope
            this.blockScopeStack = [this.createBlockScope()];
        }
        BlockScopeAwareRuleWalker.prototype.createBlockScope = function () {
            throw Lint.abstract();
        };
        BlockScopeAwareRuleWalker.prototype.getCurrentBlockScope = function () {
            return this.blockScopeStack[this.blockScopeStack.length - 1];
        };
        // callback notifier when a block scope begins
        BlockScopeAwareRuleWalker.prototype.onBlockScopeStart = function () {
            return;
        };
        BlockScopeAwareRuleWalker.prototype.getCurrentBlockDepth = function () {
            return this.blockScopeStack.length;
        };
        // callback notifier when a block scope ends
        BlockScopeAwareRuleWalker.prototype.onBlockScopeEnd = function () {
            return;
        };
        BlockScopeAwareRuleWalker.prototype.visitNode = function (node) {
            var isNewBlockScope = this.isBlockScopeBoundary(node);
            if (isNewBlockScope) {
                this.blockScopeStack.push(this.createBlockScope());
            }
            this.onBlockScopeStart();
            _super.prototype.visitNode.call(this, node);
            this.onBlockScopeEnd();
            if (isNewBlockScope) {
                this.blockScopeStack.pop();
            }
        };
        BlockScopeAwareRuleWalker.prototype.isBlockScopeBoundary = function (node) {
            return _super.prototype.isScopeBoundary.call(this, node)
                || node.kind === 184 /* DoStatement */
                || node.kind === 185 /* WhileStatement */
                || node.kind === 186 /* ForStatement */
                || node.kind === 187 /* ForInStatement */
                || node.kind === 188 /* ForOfStatement */
                || node.kind === 192 /* WithStatement */
                || node.kind === 193 /* SwitchStatement */
                || (node.parent != null
                    && (node.parent.kind === 196 /* TryStatement */
                        || node.parent.kind === 183 /* IfStatement */));
        };
        return BlockScopeAwareRuleWalker;
    })(Lint.ScopeAwareRuleWalker);
    Lint.BlockScopeAwareRuleWalker = BlockScopeAwareRuleWalker;
})(Lint || (Lint = {}));
/*
 * Copyright 2015 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    var SkippableTokenAwareRuleWalker = (function (_super) {
        __extends(SkippableTokenAwareRuleWalker, _super);
        function SkippableTokenAwareRuleWalker(sourceFile, options) {
            _super.call(this, sourceFile, options);
            this.tokensToSkipStartEndMap = {};
        }
        SkippableTokenAwareRuleWalker.prototype.visitRegularExpressionLiteral = function (node) {
            this.addTokenToSkipFromNode(node);
            _super.prototype.visitRegularExpressionLiteral.call(this, node);
        };
        SkippableTokenAwareRuleWalker.prototype.visitIdentifier = function (node) {
            this.addTokenToSkipFromNode(node);
            _super.prototype.visitIdentifier.call(this, node);
        };
        SkippableTokenAwareRuleWalker.prototype.visitTemplateExpression = function (node) {
            this.addTokenToSkipFromNode(node);
            _super.prototype.visitTemplateExpression.call(this, node);
        };
        SkippableTokenAwareRuleWalker.prototype.addTokenToSkipFromNode = function (node) {
            if (node.getStart() < node.getEnd()) {
                // only add to the map nodes whose end comes after their start, to prevent infinite loops
                this.tokensToSkipStartEndMap[node.getStart()] = node.getEnd();
            }
        };
        return SkippableTokenAwareRuleWalker;
    })(Lint.RuleWalker);
    Lint.SkippableTokenAwareRuleWalker = SkippableTokenAwareRuleWalker;
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
*/
var Lint;
(function (Lint) {
    var Configuration;
    (function (Configuration) {
        var fs = require("fs");
        var path = require("path");
        var findup = require("findup-sync");
        var CONFIG_FILENAME = "tslint.json";
        var DEFAULT_CONFIG = {
            "rules": {
                "curly": true,
                "indent": [true, 4],
                "no-duplicate-key": true,
                "no-duplicate-variable": true,
                "no-empty": true,
                "no-eval": true,
                "no-trailing-whitespace": true,
                "no-unreachable": true,
                "no-use-before-declare": true,
                "quotemark": [true, "double"],
                "semicolon": true
            }
        };
        function findConfiguration(configFile, inputFileLocation) {
            if (configFile) {
                return JSON.parse(fs.readFileSync(configFile, "utf8"));
            }
            // First look for package.json from input file location
            configFile = findup("package.json", { cwd: inputFileLocation, nocase: true });
            if (configFile) {
                var content = require(configFile);
                if (content.tslintConfig) {
                    return content.tslintConfig;
                }
            }
            // Next look for tslint.json
            var homeDir = getHomeDir();
            if (!homeDir) {
                return undefined;
            }
            var defaultPath = path.join(homeDir, CONFIG_FILENAME);
            configFile = findup(CONFIG_FILENAME, { cwd: inputFileLocation, nocase: true }) || defaultPath;
            if (fs.existsSync(configFile)) {
                return JSON.parse(fs.readFileSync(configFile, "utf8"));
            }
            else {
                return DEFAULT_CONFIG;
            }
        }
        Configuration.findConfiguration = findConfiguration;
        function getHomeDir() {
            var environment = global.process.env;
            var paths = [environment.USERPROFILE, environment.HOME, environment.HOMEPATH, environment.HOMEDRIVE + environment.HOMEPATH];
            for (var homeIndex in paths) {
                if (paths.hasOwnProperty(homeIndex)) {
                    var homePath = paths[homeIndex];
                    if (homePath && fs.existsSync(homePath)) {
                        return homePath;
                    }
                }
            }
        }
    })(Configuration = Lint.Configuration || (Lint.Configuration = {}));
})(Lint || (Lint = {}));
/*
 * Copyright 2014 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
*/
var Lint;
(function (Lint) {
    var EnableDisableRulesWalker = (function (_super) {
        __extends(EnableDisableRulesWalker, _super);
        function EnableDisableRulesWalker() {
            _super.apply(this, arguments);
            this.enableDisableRuleMap = {};
        }
        EnableDisableRulesWalker.prototype.visitSourceFile = function (node) {
            var _this = this;
            _super.prototype.visitSourceFile.call(this, node);
            Lint.scanAllTokens(ts.createScanner(1 /* ES5 */, false, node.text), function (scanner) {
                var startPos = scanner.getStartPos();
                if (_this.tokensToSkipStartEndMap[startPos] != null) {
                    // tokens to skip are places where the scanner gets confused about what the token is, without the proper context
                    // (specifically, regex, identifiers, and templates). So skip those tokens.
                    scanner.setTextPos(_this.tokensToSkipStartEndMap[startPos]);
                    return;
                }
                if (scanner.getToken() === 3 /* MultiLineCommentTrivia */) {
                    var commentText = scanner.getTokenText();
                    var startPosition = scanner.getTokenPos();
                    _this.handlePossibleTslintSwitch(commentText, startPosition);
                }
            });
        };
        EnableDisableRulesWalker.prototype.handlePossibleTslintSwitch = function (commentText, startingPosition) {
            var _this = this;
            var currentPosition = startingPosition;
            // regex is: start of string followed by "/*" followed by any amount of whitespace followed by "tslint:"
            if (commentText.match(/^\/\*\s*tslint:/)) {
                var commentTextParts = commentText.split(":");
                // regex is: start of string followed by either "enable" or "disable"
                // followed by either whitespace or end of string
                var enableOrDisableMatch = commentTextParts[1].match(/^(enable|disable)(\s|$)/);
                if (enableOrDisableMatch != null) {
                    var isEnabled = enableOrDisableMatch[1] === "enable";
                    var position = currentPosition;
                    var rulesList = ["all"];
                    if (commentTextParts.length > 2) {
                        rulesList = commentTextParts[2].split(/\s+/);
                    }
                    rulesList.forEach(function (ruleToAdd) {
                        if (!(ruleToAdd in _this.enableDisableRuleMap)) {
                            _this.enableDisableRuleMap[ruleToAdd] = [];
                        }
                        _this.enableDisableRuleMap[ruleToAdd].push({ position: position, isEnabled: isEnabled });
                    });
                }
            }
        };
        return EnableDisableRulesWalker;
    })(Lint.SkippableTokenAwareRuleWalker);
    Lint.EnableDisableRulesWalker = EnableDisableRulesWalker;
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
*/
var Lint;
(function (Lint) {
    var fs = require("fs");
    var path = require("path");
    var _s = require("underscore.string");
    var moduleDirectory = path.dirname(module.filename);
    var CORE_FORMATTERS_DIRECTORY = path.resolve(moduleDirectory, "..", "build", "formatters");
    function findFormatter(name, formattersDirectory) {
        if (typeof (name) === "function") {
            return name;
        }
        var camelizedName = _s.camelize(name + "Formatter");
        // first check for core formatters
        var Formatter = loadFormatter(CORE_FORMATTERS_DIRECTORY, camelizedName);
        if (Formatter) {
            return Formatter;
        }
        // then check for rules within the first level of rulesDirectory
        if (formattersDirectory) {
            Formatter = loadFormatter(formattersDirectory, camelizedName);
            if (Formatter) {
                return Formatter;
            }
        }
        // else try to resolve as module
        return loadFormatterModule(name);
    }
    Lint.findFormatter = findFormatter;
    function loadFormatter() {
        var paths = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            paths[_i - 0] = arguments[_i];
        }
        var formatterPath = paths.reduce(function (p, c) { return path.join(p, c); }, "");
        var fullPath = path.resolve(moduleDirectory, formatterPath);
        if (fs.existsSync(fullPath + ".js")) {
            var formatterModule = require(fullPath);
            return formatterModule.Formatter;
        }
        return undefined;
    }
    function loadFormatterModule(name) {
        var src;
        try {
            src = require.resolve(name);
        }
        catch (e) {
            return undefined;
        }
        return require(src).Formatter;
    }
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
*/
var Lint;
(function (Lint) {
    var fs = require("fs");
    var path = require("path");
    var _s = require("underscore.string");
    var moduleDirectory = path.dirname(module.filename);
    var CORE_RULES_DIRECTORY = path.resolve(moduleDirectory, "..", "build", "rules");
    function loadRules(ruleConfiguration, enableDisableRuleMap, rulesDirectory) {
        var rules = [];
        for (var ruleName in ruleConfiguration) {
            if (ruleConfiguration.hasOwnProperty(ruleName)) {
                var ruleValue = ruleConfiguration[ruleName];
                var Rule = findRule(ruleName, rulesDirectory);
                if (Rule !== undefined) {
                    var all = "all"; // make the linter happy until we can turn it on and off
                    var allList = (all in enableDisableRuleMap ? enableDisableRuleMap[all] : []);
                    var ruleSpecificList = (ruleName in enableDisableRuleMap ? enableDisableRuleMap[ruleName] : []);
                    var disabledIntervals = buildDisabledIntervalsFromSwitches(ruleSpecificList, allList);
                    rules.push(new Rule(ruleName, ruleValue, disabledIntervals));
                }
            }
        }
        return rules;
    }
    Lint.loadRules = loadRules;
    function findRule(name, rulesDirectory) {
        var camelizedName = transformName(name);
        // first check for core rules
        var Rule = loadRule(CORE_RULES_DIRECTORY, camelizedName);
        if (Rule) {
            return Rule;
        }
        // then check for rules within the first level of rulesDirectory
        if (rulesDirectory) {
            Rule = loadRule(rulesDirectory, camelizedName);
            if (Rule) {
                return Rule;
            }
        }
        // finally check for rules within the first level of directories,
        // using dash prefixes as the sub-directory names
        if (rulesDirectory) {
            var subDirectory = _s.strLeft(rulesDirectory, "-");
            var ruleName = _s.strRight(rulesDirectory, "-");
            if (subDirectory !== rulesDirectory && ruleName !== rulesDirectory) {
                camelizedName = transformName(ruleName);
                Rule = loadRule(rulesDirectory, subDirectory, camelizedName);
                if (Rule) {
                    return Rule;
                }
            }
        }
        return undefined;
    }
    Lint.findRule = findRule;
    function transformName(name) {
        // camelize strips out leading and trailing underscores and dashes, so make sure they aren't passed to camelize
        // the regex matches the groups (leading underscores and dashes)(other characters)(trailing underscores and dashes)
        var nameMatch = name.match(/^([-_]*)(.*?)([-_]*)$/);
        if (nameMatch == null) {
            return name + "Rule";
        }
        return nameMatch[1] + _s.camelize(nameMatch[2]) + nameMatch[3] + "Rule";
    }
    function loadRule() {
        var paths = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            paths[_i - 0] = arguments[_i];
        }
        var rulePath = paths.reduce(function (p, c) { return path.join(p, c); }, "");
        var fullPath = path.resolve(moduleDirectory, rulePath);
        if (fs.existsSync(fullPath + ".js")) {
            var ruleModule = require(fullPath);
            if (ruleModule && ruleModule.Rule) {
                return ruleModule.Rule;
            }
        }
        return undefined;
    }
    /*
     * we're assuming both lists are already sorted top-down
     * so compare the tops, use the smallest of the two, and build the intervals that way
     */
    function buildDisabledIntervalsFromSwitches(ruleSpecificList, allList) {
        var isCurrentlyDisabled = false;
        var disabledStartPosition;
        var disabledIntervalList = [];
        var i = 0;
        var j = 0;
        while (i < ruleSpecificList.length || j < allList.length) {
            var ruleSpecificTopPositon = (i < ruleSpecificList.length ? ruleSpecificList[i].position : Infinity);
            var allTopPositon = (j < allList.length ? allList[j].position : Infinity);
            var newPositionToCheck;
            if (ruleSpecificTopPositon < allTopPositon) {
                newPositionToCheck = ruleSpecificList[i];
                i++;
            }
            else {
                newPositionToCheck = allList[j];
                j++;
            }
            // we're currently disabled and enabling, or currently enabled and disabling -- a switch
            if (newPositionToCheck.isEnabled === isCurrentlyDisabled) {
                if (!isCurrentlyDisabled) {
                    // start a new interval
                    disabledStartPosition = newPositionToCheck.position;
                    isCurrentlyDisabled = true;
                }
                else {
                    // we're currently disabled and about to enable -- end the interval
                    disabledIntervalList.push({ startPosition: disabledStartPosition, endPosition: newPositionToCheck.position });
                    isCurrentlyDisabled = false;
                }
            }
        }
        if (isCurrentlyDisabled) {
            // we started an interval but didn't finish one -- so finish it with an Infinity
            disabledIntervalList.push({ startPosition: disabledStartPosition, endPosition: Infinity });
        }
        return disabledIntervalList;
    }
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    var path = require("path");
    var moduleDirectory = path.dirname(module.filename);
    var Linter = (function () {
        function Linter(fileName, source, options) {
            this.fileName = fileName;
            this.source = source;
            this.options = options;
        }
        Linter.prototype.lint = function () {
            var _this = this;
            var failures = [];
            var sourceFile = Lint.getSourceFile(this.fileName, this.source);
            // walk the code first to find all the intervals where rules are disabled
            var rulesWalker = new Lint.EnableDisableRulesWalker(sourceFile, { ruleName: "", disabledIntervals: [] });
            rulesWalker.walk(sourceFile);
            var enableDisableRuleMap = rulesWalker.enableDisableRuleMap;
            var rulesDirectory = this.getRelativePath(this.options.rulesDirectory);
            var configuration = this.options.configuration.rules;
            var configuredRules = Lint.loadRules(configuration, enableDisableRuleMap, rulesDirectory);
            for (var i = 0; i < configuredRules.length; ++i) {
                var rule = configuredRules[i];
                if (rule.isEnabled()) {
                    var ruleFailures = rule.apply(sourceFile);
                    ruleFailures.forEach(function (ruleFailure) {
                        if (!_this.containsRule(failures, ruleFailure)) {
                            failures.push(ruleFailure);
                        }
                    });
                }
            }
            var formatter;
            var formattersDirectory = this.getRelativePath(this.options.formattersDirectory);
            var Formatter = Lint.findFormatter(this.options.formatter, formattersDirectory);
            if (Formatter) {
                formatter = new Formatter();
            }
            else {
                throw new Error("formatter '" + this.options.formatter + "' not found");
            }
            var output = formatter.format(failures);
            return {
                failureCount: failures.length,
                format: this.options.formatter,
                output: output
            };
        };
        Linter.prototype.getRelativePath = function (directory) {
            if (directory) {
                return path.relative(moduleDirectory, directory);
            }
            return undefined;
        };
        Linter.prototype.containsRule = function (rules, rule) {
            for (var i = 0; i < rules.length; ++i) {
                if (rules[i].equals(rule)) {
                    return true;
                }
            }
            return false;
        };
        Linter.VERSION = "2.3.0-beta";
        return Linter;
    })();
    Lint.Linter = Linter;
})(Lint || (Lint = {}));
// add the Lint and TypeScript modules to global for pluggable formatters/rules
global.Lint = Lint;
global.ts = ts;
// export Lint.Linter as the API interface for this module
module.exports = Lint.Linter;
// also export Lint.Configuration.findConfiguration so implementers can consume
module.exports.findConfiguration = Lint.Configuration.findConfiguration;
